VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuContainerOwnerDrawing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Stores extra parameters used to draw Office 97 like menus yourself."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

'==================================================================
'
' Storage for MenuContainer owner drawing properties Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' Declarations

Private CurBackground As IPicture
Private CurImageList(mnuImageNormal To mnuImageChecked) As ImageListCore.ImageList


'------------------------------------------------------------------------
' Default settings

Private Sub Class_Initialize()
  Set CurBackground = GetPictureObj(0)  ' Default background
End Sub


'------------------------------------------------------------------------


'------------------------------------------------------------------------
' Specify the graphics used for drawing

Public Property Get Background() As IPicture
Attribute Background.VB_Description = "Contains the background bitmap used by the entire popup menu."
  Set Background = CurBackground
End Property

Public Property Set Background(ByVal NewValue As IPicture)
  Const ERR_SRC = SRC_CLASS_MENU_DRAW & "BackGround" & SRC_PROP_SET
  If NewValue Is Nothing Then Err.Raise 380, ERR_SRC, ERR_SETIMAGE_NULL
  If Not TypeOf NewValue Is IPicture _
  And Not TypeOf NewValue Is IPictureDisp _
  And Not TypeOf NewValue Is StdPicture Then Err.Raise 380, ERR_SRC, ERR_SETIMAGE_TYPE
  Set CurBackground = NewValue
End Property

Public Property Get ImageLists(ByVal Index As MenuItemImages) As ImageListCore.ImageList
Attribute ImageLists.VB_Description = "Contains several lists with images, used to draw cool menu items."
  Set ImageLists = CurImageList(Index)
End Property

Public Property Set ImageLists(ByVal Index As MenuItemImages, ByVal NewValue As ImageListCore.ImageList)
  Const ERR_SRC = SRC_CLASS_MENU_DRAW & "ImageLists" & SRC_PROP_SET
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is ImageListCore.ImageList Then Err.Raise 380, ERR_SRC, ERR_TYPE & "ImageListCore.ImageList!"
  End If
  Set CurImageList(Index) = NewValue
End Property
