VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GMenuFunctions"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'==================================================================
'
' Global Used Menu Declarations and Functions
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' Public enums: MenuContainer

Public Enum MenuTypeConstants
  mnuTypeMenuBar = 0
  mnuTypeSubMenu = 1
End Enum

Public Enum MenuStyles
  mnuStyleAutoClose = &H10000000      ' MNS_AUTODISMISS
  mnuStyleShowCheckOrIcon = &H4000000 ' MNS_CHECKORBMP
  mnuStyleOLEDragDrop = &H20000000    ' MNS_DRAGDROP
  mnuStyleModeLess = &H40000000       ' MNS_MODELESS
  mnuStyleNoCheckSpace = &H80000000   ' MNS_NOCHECK
  mnuStyleNotifyByPos = &H8000000     ' MNS_NOTIFYBYPOS
End Enum

Public Enum MenuPopupFlags
  mnuPopupLeftBtnClose = &H0        ' TPM_LEFTBUTTON
  mnuPopupRightBtnClose = &H2       ' TPM_RIGHTBUTTON
  mnuPopupAlignLeft = &H0           ' TPM_LEFTALIGN
  mnuPopupAlignCenter = &H4         ' TPM_CENTERALIGN
  mnuPopupAlignRight = &H8          ' TPM_RIGHTALIGN
  
  mnuPopupAlignTop = &H0            ' TPM_TOPALIGN
  mnuPopupAlignMiddle = &H10        ' TPM_VCENTERALIGN
  mnuPopupBottom = &H20             ' TPM_BOTTOMALIGN
  
  mnuPopupAlignMatterHorMore = &H0  ' TPM_HORIZONTAL      ' Horz alignment matters more
  mnuPopupAlignMatterVerMore = &H40 ' TPM_VERTICAL        ' Vert alignment matters more
  mnuPopupNoNotifications = &H80    ' TPM_NONOTIFY        ' Don't send any notification msgs
  mnuPopupReturnID = &H100          ' TPM_RETURNCMD
  mnuPopupRecursePopupMenus = &H1   ' TPM_RECURSE         ' W98
End Enum

Public Enum MenuGetDefaultItemFlags
  mnuSearchDisabledToo = &H1  ' GMDI_USEDISABLED
  mnuSearchInSubmenus = &H2   ' GMDI_GOINTOPOPUPS
End Enum

'------------------------------------------------------------------------
' Public enums: MenuItem

Public Enum MenuTypeFlags
  mnuFlagString = &H0               ' MFT_STRING | MF_STRING
  mnuFlagBitmap = &H4               ' MFT_BITMAP | MF_BITMAP
  mnuFlagBreakSeparator = &H20            ' MFT_MENUBARBREAK | MF_MENUBARBREAK
  mnuFlagBreak = &H40               ' MFT_MENUBREAK | MF_MENUBREAK
  mnuFlagCheckRadio = &H200         ' MFT_RADIOCHECK
  mnuFlagSeparator = &H800          ' MFT_SEPARATOR | MF_SEPARATOR
  mnuFlagRightOrder = &H2000        ' MFT_RIGHTORDER
  mnuFlagRightJustify = &H4000      ' MFT_RIGHTJUSTIFY | MF_RIGHTJUSTIFY
  mnuFlagDrawnByOwner = &H100       ' MFT_OWNERDRAW | MF_OWNERDRAW
End Enum

Public Enum MenuStateFlags
  mnuStateGrayed = &H3     ' MFS_GRAYED
  mnuStateChecked = &H8    ' MF_CHECKED
  mnuStateHilite = &H80    ' MF_HILITE
  mnuStateDefault = &H1000 ' MF_DEFAULT
End Enum

Public Enum MenuStandardBitmaps
  mnuBitmapByCallback = -1          ' HBMMENU_CALLBACK
  mnuBitmapDefault = 0
  mnuBitmapSystem = 1               ' HBMMENU_SYSTEM
  mnuBitmapBarRestore = 2           ' HBMMENU_MBAR_RESTORE
  mnuBitmapBarMinimize = 3          ' HBMMENU_MBAR_MINIMIZE
  mnuBitmapBarMinimizeDisabled = 7  ' HBMMENU_MBAR_MINIMIZE_D
  mnuBitmapBarClose = 5             ' HBMMENU_MBAR_CLOSE
  mnuBitmapBarCloseDisabled = 6     ' HBMMENU_MBAR_CLOSE_D
  mnuBitmapPopupClose = 8            ' HBMMENU_POPUP_CLOSE
  mnuBitmapPopupRestore = 9          ' HBMMENU_POPUP_RESTORE
  mnuBitmapPopupMaximize = 10        ' HBMMENU_POPUP_MAXIMIZE
  mnuBitmapPopupMinimize = 11        ' HBMMENU_POPUP_MINIMIZE
End Enum

Public Enum MenuItemIndexType
  mnuItemByID = &H0         ' MF_BYCOMMAND
  mnuItemByPosition = &H400 ' MF_BYPOSITION
End Enum

'------------------------------------------------------------------------
' Public enums: Owner Drawing storage

Public Enum MenuItemImages
  mnuImageNormal = 0
  mnuImageSelected = 1
  mnuImageChecked = 2
End Enum

Public Enum MenuItemColors
  mnuClrMenuText = 0
  mnuClrBackground = 1
  mnuClrSelText = 2
  mnuClrSelBackground = 3
End Enum

Public Enum MenuItemMetrics
  mnuMtrWidth = 1
  mnuMtrHeight = 2
  mnuMtrSize = mnuMtrWidth Or mnuMtrHeight
  mnuMtrIconWidth = 5
  mnuMtrIconHeight = 6
  mnuMtrIconSize = mnuMtrIconWidth Or mnuMtrIconHeight
End Enum

Public Enum MenuItemBitmaps
  mnuBmpDefault = 0
  mnuBmpChecked = 1
  mnuBmpBackground = 2
End Enum


'------------------------------------------------------------------------
' Public enums: Event Handling

Public Enum MenuWinProcMessages
  WM_CONTEXTMENU = &H7B
  WM_DRAWITEM = &H2B
  WM_ENTERMENULOOP = &H211
  WM_EXITMENULOOP = &H212
  WM_INITMENU = &H116
  WM_INITMENUPOPUP = &H117
  WM_MEASUREITEM = &H2C
  WM_MENUCHAR = &H120
  WM_MENUCOMMAND = &H126    ' W98
  WM_MENUDRAG = &H123       ' W98
  WM_MENUGETOBJECT = &H124  ' W98
  WM_MENURBUTTONUP = &H122  ' W98
  WM_MENUSELECT = &H11F
  WM_NEXTMENU = &H213
  WM_SYSCOMMAND = &H112
  WM_UNINITMENUPOPUP = &H125
  WM_MDIREFRESHMENU = &H234
  WM_MDISETMENU = &H230
  WM_SETTINGCHANGE = &H1A
End Enum

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type DRAWITEMSTRUCT
  CtlType As Long
  CtlID As Long
  ItemID As Long
  ItemAction As Long
  ItemState As Long
  hWndItem As Long
  hDC As Long
  rcItem As RECT
  ItemData As Long
End Type

Public Type SIZE
  CX As Long
  CY As Long
End Type

Public Type MEASUREITEMSTRUCT
  CtlType As Long
  CtlID As Long
  ItemID As Long
  ItemWidth As Long
  ItemHeight As Long
  ItemData As Long
End Type

Public Type MENUGETOBJECTINFO
  dwFlags As Long
  uPos As Long
  hMenu As Long
  riid As Long ' Object
  pvObj As Long ' Object
End Type

Public Type MDINEXTMENU
  hmenuIn As Long
  hMenuNext As Long
  hWndNext As Long
End Type

Public Enum MenuDrawItemControlConstants
  mnuDrawCtlMenu = 1       ' ODT_MENU
  mnuDrawCtlListBox = 2    ' ODT_LISTBOX
  mnuDrawCtlComboBox = 3   ' ODT_COMBOBOX
  mnuDrawCtlButton = 4     ' ODT_BUTTON
  mnuDrawCtlStatic = 5     ' ODT_STATIC
  mnuDrawCtlTabStrip = 101 ' ODT_TAB
  mnuDrawCtlListView = 102 ' ODT_LISTVIEW
End Enum

Public Enum MenuDrawItemMethod
  mnuDrawEntireControl = &H1         ' ODA_DRAWENTIRE
  mnuDrawSelectionChange = &H2       ' ODA_SELECT
  mnuDrawFocusChange = &H4           ' ODA_FOCUS
End Enum

Public Enum MenuDrawItemStates
  mnuDrawStateSelected = &H1         ' ODS_SELECTED
  mnuDrawStateGrayed = &H2           ' ODS_GRAYED
  mnuDrawStateDisabled = &H4         ' ODS_DISABLED
  mnuDrawStateChecked = &H8          ' ODS_CHECKED
  mnuDrawStateFocus = &H10           ' ODS_FOCUS
  mnuDrawStateDefault = &H20         ' ODS_DEFAULT
' ODS_COMBOBOXEDIT = &H1000          ' ODS_COMBOBOXEDIT
  mnuDrawStateHotLight = &H40        ' ODS_HOTLIGHT: W98
  mnuDrawStateInActive = &H80        ' ODS_INACTIVE: W98
End Enum

Public Enum MenuContainerType
  mnuTypePopup = &H10     ' MF_POPUP
  mnuTypeSysMenu = &H2000 ' MF_SYSMENU
End Enum

Public Enum MenuItemFromCharReturnValue
  mnuCharDiscardChar = 0      ' MNC_IGNORE
  mnuCharCloseContainer = 1   ' MNC_CLOSE
  mnuCharExecMenuItem = 2     ' MNC_EXECUTE
  mnuCharSelectMenuItem = 3   ' MNC_SELECT
End Enum

Public Enum MenuItemSelectFlags
  mnuSelStateBitmap = &H4          ' MF_BITMAP
  mnuSelStateChecked = &H8         ' MF_CHECKED
  mnuSelStateDisabled = &H2        ' MF_DISABLED
  mnuSelStateGrayed = &H1          ' MF_GRAYED
  mnuSelStateHilite = &H80         ' MF_HILITE
  mnuSelMouseSelect = &H8000       ' MF_MOUSESELECT
  mnuSelStateOwnerDraw = &H100     ' MF_OWNERDRAW
End Enum

Public Enum MenuSysCommandTypes
  mnuSysCmdSize = &HF000         ' SC_SIZE
  mnuSysCmdMove = &HF010         ' SC_MOVE
  mnuSysCmdMinimize = &HF020     ' SC_MINIMIZE
  mnuSysCmdMaximize = &HF030     ' SC_MAXIMIZE
  mnuSysCmdNextWindow = &HF040   ' SC_NEXTWINDOW
  mnuSysCmdPrevWindow = &HF050   ' SC_PREVWINDOW
  mnuSysCmdClose = &HF060        ' SC_CLOSE
  mnuSysCmdVScroll = &HF070      ' SC_VSCROLL
  mnuSysCmdHScroll = &HF080      ' SC_HSCROLL
  mnuSysCmdMouseMenu = &HF090    ' SC_MOUSEMENU
  mnuSysCmdKeyMenu = &HF100      ' SC_KEYMENU
  mnuSysCmdArrange = &HF110      ' SC_ARRANGE
  mnuSysCmdrestore = &HF120      ' SC_RESTORE
  mnuSysCmdTaskList = &HF130     ' SC_TASKLIST
  mnuSysCmdScreenSave = &HF140   ' SC_SCREENSAVE
  mnuSysCmdHotKey = &HF150       ' SC_HOTKEY
  mnuSysCmdDefault = &HF160      ' SC_DEFAULT
  mnuSysCmdMonitorPower = &HF170 ' SC_MONITORPOWER
  mnuSysCmdContextHelp = &HF180  ' SC_CONTEXTHELP
  mnuSysCmdSepararor = &HF00F    ' SC_SEPARATOR
End Enum

Public Enum MenuDragReturnValue
  mnuDragContinue = 0   ' MND_CONTINUE
  mnuDragEndMenu = 1    ' MND_ENDMENU
End Enum

Public Enum MenuGetObjectReturnValue
  mnuGetObjNoInterface = &H0 ' MNGO_NOINTERFACE
  mnuGetObjNoError = &H1     ' MNGO_NOERROR
End Enum



'------------------------------------------------------------------------
' Creating a new menu from scratch

'Public Function CreateMenuBar() As MenuContainer
'  Dim hMenu As OLE_HANDLE
'  hMenu = CreateMenu()
'  If hMenu = 0 Then Call RaiseVBDLLError("MenuGlobal.CreateMenuBar()", "Menu bar creation failed: ")
'  Set CreateMenuBar = MenuAttach(hMenu, True)
'  CreateMenuBar.OwnsHandle = True
'End Function

Public Function CreateSubMenu() As MenuContainer
  Dim hMenu As OLE_HANDLE
  hMenu = CreatePopupMenu()
  If hMenu = 0 Then Call RaiseVBDLLError("MenuGlobal.CreateSubMenu()", "Popuo menu creation failed: ")
  Set CreateSubMenu = MenuAttach(hMenu, True)
End Function

'------------------------------------------------------------------------
' Loading a menu from resource

Public Function LoadResMenu(ByVal hInstance As OLE_HANDLE, ByVal MenuResName As Variant) As MenuContainer
  Dim hMenu As OLE_HANDLE
  If Val(MenuResName) = MenuResName Then
    hMenu = LoadMenuByLong(hInstance, CLng(CInt(MenuResName)))
  ElseIf VarType(MenuResName) = vbString Then
    hMenu = LoadMenuByString(hInstance, CStr(MenuResName))
  End If
  If hMenu = 0 Then Call RaiseVBDLLError("MenuGlobal.LoadResMenu()", "Menu loading failed: ")
  Set LoadResMenu = MenuAttach(hMenu, True)
End Function

'------------------------------------------------------------------------
' Attaching to a popup menu

Public Function MenuAttach(ByVal hMenu As OLE_HANDLE, Optional ByVal OwnsHandle As Boolean = True) As MenuContainer
  If IsMenu(hMenu) = 0 Then Error 5
  ' Store the menu container object pointer.
  Dim MENUINFO As MENUINFO
  MENUINFO.cbSize = LenB(MENUINFO)
  MENUINFO.fMask = MIM_MENUDATA
  If GetMenuInfo(hMenu, MENUINFO) = 0 Then Error 380
  If -MENUINFO.dwMenuData < OBJPTR_BASE Then
    Set MenuAttach = New MenuContainer
    MENUINFO.dwMenuData = -ObjPtr(MenuAttach)
    If SetMenuInfo(hMenu, MENUINFO) = 0 Then Error 383
    Call MenuAttach.Class_InitProps(hMenu)
    MenuAttach.OwnsHandle = OwnsHandle
  Else
    Set MenuAttach = GetObjFromPtr(-MENUINFO.dwMenuData)
  End If
End Function

'------------------------------------------------------------------------
' Close all menus in current thread

Public Sub ColapseMenus()
  If EndMenu() = 0 Then Call RaiseVBDLLError("MenuGlobal.ColapseMenus()", "ColapseMenus failed: ")
End Sub

'------------------------------------------------------------------------
' MenuBars on windows

Public Function GetMenuBar(ByVal hWnd As OLE_HANDLE) As MenuContainer
  If IsWindow(hWnd) = 0 Then Error 5
  If GetParent(hWnd) <> 0 Then Error 5
  Set GetMenuBar = MenuAttach(GetMenu(hWnd), True)
End Function

'------------------------------------------------------------------------
' System menus on windows

Public Function GetSystemMenu(ByVal hWnd As OLE_HANDLE) As MenuContainer
  If IsWindow(hWnd) = 0 Then Error 5
  If GetParent(hWnd) <> 0 Then Error 5
  Dim hMenu As OLE_HANDLE
  hMenu = GetSystemMenuAPI(hWnd, 0)
  Set GetSystemMenu = MenuAttach(hMenu, False) ' OwnsHandle = False !!
End Function

Public Sub ResetSystemMenu(ByVal hWnd As OLE_HANDLE)
  If IsWindow(hWnd) = 0 Then Error 5
  If GetParent(hWnd) <> 0 Then Error 5
  Call GetSystemMenuAPI(hWnd, 1)
End Sub

Public Sub RefreshMenuBar(ByVal hWnd As OLE_HANDLE)
  If IsWindow(hWnd) = 0 Then Error 5
  If GetParent(hWnd) <> 0 Then Error 5
  If DrawMenuBar(hWnd) = 0 Then Error 5
End Sub

'------------------------------------------------------------------------
' Menu bitmap metrics

Public Function GetMenuCheckMarkWidth() As Integer
  GetMenuCheckMarkWidth = GetMenuCheckMarkDimensions().LoWord
End Function

Public Function GetMenuCheckMarkHeight() As Integer
  GetMenuCheckMarkHeight = GetMenuCheckMarkDimensions().HiWord
End Function

'------------------------------------------------------------------------
' Menu Owner Drawing

Public Function MenuPopup_GetMsgItem(ByVal MsgItemData As Long) As MenuItem
  Set MenuPopup_GetMsgItem = GetObjFromPtr(-MsgItemData)
  If MenuPopup_GetMsgItem Is Nothing Then Error 5
End Function

Public Function MenuPopup_GetMsgContainer(ByVal MsgItemData As Long) As MenuContainer
  Set MenuPopup_GetMsgContainer = GetObjFromPtr(-MsgItemData)
  If MenuPopup_GetMsgContainer Is Nothing Then Error 5
End Function

Public Function MenuPopup_GetOwnerDrawItem(ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long)
  Select Case WindowMessage
    Case WM_DRAWITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim DRAWITEMSTRUCT As DRAWITEMSTRUCT
          Call CopyMemory(DRAWITEMSTRUCT, ByVal lParam, LenB(DRAWITEMSTRUCT))
          If DRAWITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuPopup_GetOwnerDrawItem = GetObjFromPtr(-DRAWITEMSTRUCT.ItemData)
          End If
        End If
    Case WM_MEASUREITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim MEASUREITEMSTRUCT As MEASUREITEMSTRUCT
          Call CopyMemory(MEASUREITEMSTRUCT, ByVal lParam, LenB(MEASUREITEMSTRUCT))
          If MEASUREITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuPopup_GetOwnerDrawItem = GetObjFromPtr(-MEASUREITEMSTRUCT.ItemData)
          End If
        End If
  End Select
End Function

Public Function MenuPopup_HandleDrawMsg(ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As Boolean
  Dim MenuItem As MenuItem
  Dim MenuContainer As MenuContainer
  Dim MenuSize As SIZE
  Select Case WindowMessage
    Case WM_DRAWITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim DRAWITEMSTRUCT As DRAWITEMSTRUCT
          Call CopyMemory(DRAWITEMSTRUCT, ByVal lParam, LenB(DRAWITEMSTRUCT))
          If DRAWITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuItem = GetObjFromPtr(-DRAWITEMSTRUCT.ItemData)
            Set MenuContainer = MenuItem.ParentMenu
            Call MenuPopup_DrawItem(MenuContainer, MenuItem, DRAWITEMSTRUCT.rcItem.Left, DRAWITEMSTRUCT.rcItem.Top, DRAWITEMSTRUCT.rcItem.Right, DRAWITEMSTRUCT.rcItem.Bottom, DRAWITEMSTRUCT.ItemAction, DRAWITEMSTRUCT.ItemState, DRAWITEMSTRUCT.hDC, DRAWITEMSTRUCT.hWndItem)
            MenuPopup_HandleDrawMsg = True ' Confirm Handled
          End If
        End If
    Case WM_MEASUREITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim MEASUREITEMSTRUCT As MEASUREITEMSTRUCT
          Call CopyMemory(MEASUREITEMSTRUCT, ByVal lParam, LenB(MEASUREITEMSTRUCT))
          If MEASUREITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuItem = GetObjFromPtr(-MEASUREITEMSTRUCT.ItemData)
            LSet MenuSize = MenuPopup_MeasureItem(MenuItem)
            MEASUREITEMSTRUCT.ItemWidth = MenuSize.CX
            MEASUREITEMSTRUCT.ItemHeight = MenuSize.CY
            Call CopyMemory(ByVal lParam, MEASUREITEMSTRUCT, LenB(MEASUREITEMSTRUCT))
            MenuPopup_HandleDrawMsg = True ' Confirm Handled
          End If
        End If
  End Select
End Function

Public Sub MenuPopup_DrawItem(ByVal Menu As MenuContainer, ByVal MenuItem As MenuItem, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal DrawMethod As MenuDrawItemMethod, ByVal ItemState As MenuDrawItemStates, ByVal hDCItem As Long, ByVal hWndItem As Long)
  Call MenuOwnerDrawing.Menu_DrawItem(Menu, MenuItem, ItemX1, ItemY1, ItemX2, ItemY2, DrawMethod, ItemState, hDCItem, hWndItem)
End Sub

Public Function MenuPopup_MeasureItem(ByVal MenuItem As MenuItem) As SIZE
  MenuPopup_MeasureItem = MenuOwnerDrawing.Menu_MeasureItem(MenuItem)
End Function

Public Function MenuPopup_ShortCutValid(ByVal ShortCutModifier As ShiftConstants, ByVal ShortCutCode As KeyCodeConstants) As Boolean
  MenuPopup_ShortCutValid = Menu_ShortCutValid(ShortCutModifier, ShortCutCode)
End Function
