VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuItemOwnerDrawing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Contains extra parameters that can be used for drawing Office 97 look-a-like menus."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Option Explicit

'==================================================================
'
' Storage for menu item owner draw properties
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' Declarations

Private CurhMenu As OLE_HANDLE
Private CurID As Long

Private CurWidth As Long
Private CurHeight As Long

Private CurIconWidth As Long
Private CurIconHeight As Long

Private CurFont As GDIObjects.GDIFont
Private CurDefaultFont As GDIObjects.GDIFont

Private CurIcons(mnuImageNormal To mnuImageChecked) As Long
Private CurBackground As IPicture

Private CurTextColor As OLE_COLOR
Private CurBackColor As OLE_COLOR

Private CurSelTextColor As OLE_COLOR
Private CurSelBackColor As OLE_COLOR

'------------------------------------------------------------------------
' Default settings

Private Sub Class_Initialize()
  CurWidth = 6                          ' Menu item height
  CurHeight = 22                        ' Menu item height
  CurIconWidth = 16                     ' Icon width
  CurIconHeight = 16                    ' Icon height
  CurTextColor = vbMenuText             ' Normal Text color
  CurBackColor = vbMenuBar              ' Normal Background color
  CurSelTextColor = vbHighlightText     ' Highlighted forecolor
  CurSelBackColor = vbHighlight         ' Highlighted backcolor
  Set CurBackground = GetPictureObj(0)  ' Default background
End Sub

'------------------------------------------------------------------------
' Attach to menu item in menucontainer

Friend Sub Class_Attach(ByVal hMenu As OLE_HANDLE, ByVal ID As Long)
  CurhMenu = hMenu
  CurID = ID
End Sub

'------------------------------------------------------------------------
' Specify the metrics of certain menu items

Public Property Get Metrics(ByVal Index As MenuItemMetrics) As Long
Attribute Metrics.VB_Description = "Returns/Sets several metrtics of the menu item."
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "Metrics" & SRC_PROP_GET
  Select Case Index
    Case mnuMtrWidth:      Metrics = CurWidth
    Case mnuMtrHeight:     Metrics = CurHeight
    Case mnuMtrSize:       If CurWidth <> CurHeight Then Err.Raise 5, ERR_SRC, ERR_CALL & "Width/Height values aren't equal!"
                           Metrics = CurWidth
    Case mnuMtrIconWidth:  Metrics = CurIconWidth
    Case mnuMtrIconHeight: Metrics = CurIconHeight
    Case mnuMtrIconSize:   If CurIconWidth <> CurIconHeight Then Err.Raise 5, ERR_SRC, ERR_CALL & "Width/Height values aren't equal!"
                           Metrics = CurIconWidth
    Case Else:             Err.Raise 5, ERR_SRC, ERR_ARGUMENT & "Index"
  End Select
End Property

Public Property Let Metrics(ByVal Index As MenuItemMetrics, ByVal NewValue As Long)
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "Metrics" & SRC_PROP_LET
  If NewValue <= 0 Then Err.Raise 380, ERR_SRC, ERR_VALUE & "Metrics"
  Select Case Index
    Case mnuMtrWidth:      CurWidth = NewValue
    Case mnuMtrHeight:     CurHeight = NewValue
    Case mnuMtrSize:       CurWidth = NewValue
                           CurHeight = NewValue
    Case mnuMtrIconWidth:  CurIconWidth = NewValue
    Case mnuMtrIconHeight: CurIconHeight = NewValue
    Case mnuMtrIconSize:   CurIconWidth = NewValue
                           CurIconHeight = NewValue
    Case Else:             Err.Raise 5, ERR_SRC, ERR_ARGUMENT & "Index"
  End Select
End Property

'------------------------------------------------------------------------
' Specify the colors for drawing

Public Property Get Colors(ByVal Index As MenuItemColors) As OLE_COLOR
Attribute Colors.VB_Description = "Specifies several colors of the menu item."
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "Colors" & SRC_PROP_GET
  Select Case Index
    Case mnuClrMenuText:              Colors = CurTextColor
    Case mnuClrBackground:            Colors = CurBackColor
    Case mnuClrSelText:               Colors = CurSelTextColor
    Case mnuClrSelBackground:         Colors = CurSelBackColor
    Case Else:                        Err.Raise 5, ERR_SRC, ERR_ARGUMENT & "Index"
  End Select
End Property

Public Property Let Colors(ByVal Index As MenuItemColors, ByVal NewValue As OLE_COLOR)
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "Colors" & SRC_PROP_LET
  Select Case Index
    Case mnuClrMenuText:              CurTextColor = NewValue
    Case mnuClrBackground:            CurBackColor = NewValue
    Case mnuClrSelText:               CurSelTextColor = NewValue
    Case mnuClrSelBackground:         CurSelBackColor = NewValue
    Case Else:                        Err.Raise 5, ERR_SRC, ERR_ARGUMENT & "Index"
  End Select
End Property

'------------------------------------------------------------------------
' Specify the graphics used for drawing

Public Property Get IconIndex(ByVal Index As MenuItemImages) As Long
Attribute IconIndex.VB_Description = "Returns/Sets the imagelist index where the menu item can be found."
  IconIndex = CurIcons(Index)
End Property

Public Property Let IconIndex(ByVal Index As MenuItemImages, ByVal NewValue As Long)
  CurIcons(Index) = NewValue
End Property


'------------------------------------------------------------------------
' Specify the font used for normal drawing

Public Property Get NormalFont() As GDIObjects.GDIFont
Attribute NormalFont.VB_Description = "Returns the normal font used for the menu item."
  If CurFont Is Nothing Then
    Set CurFont = GetDefaultMenuFont()
  ElseIf CurFont.hFont = 0 Then
    Set CurFont = GetDefaultMenuFont()
  End If
  Set NormalFont = CurFont
End Property

Public Property Set NormalFont(ByVal NewValue As GDIObjects.GDIFont)
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "NormalFont" & SRC_PROP_SET
  If NewValue Is Nothing Then Err.Raise 5, ERR_SRC, ERR_SETFONT_NULL
  If Not TypeOf NewValue Is GDIObjects.GDIFont Then Err.Raise 380, ERR_SRC, ERR_TYPE & "GDIObjects.GDIFont!"
  Set CurFont = NewValue
End Property

'------------------------------------------------------------------------
' Specify the font used when this is the default item!

Public Property Get DefaultFont() As GDIObjects.GDIFont
Attribute DefaultFont.VB_Description = "Returns/Sets the default font for the menu item."
  If CurDefaultFont Is Nothing Then
    Set CurDefaultFont = GetDefaultMenuFont(, True)
  ElseIf CurDefaultFont.hFont = 0 Then
    Set CurDefaultFont = GetDefaultMenuFont(, True)
  End If
  Set DefaultFont = CurDefaultFont
End Property

Public Property Set DefaultFont(ByVal NewValue As GDIObjects.GDIFont)
  Const ERR_SRC = SRC_CLASS_MENUITEM_DRAW & "DefaultFont" & SRC_PROP_SET
  If NewValue Is Nothing Then Err.Raise 5, ERR_SRC, ERR_SETFONT_NULL
  If Not TypeOf NewValue Is GDIObjects.GDIFont Then Err.Raise 380, ERR_SRC, ERR_TYPE & "GDIObjects.GDIFont!"
  Set CurDefaultFont = NewValue
End Property

'------------------------------------------------------------------------
' Clear the font settings

Public Sub RestoreFont()
Attribute RestoreFont.VB_Description = "Restores the normal font used for menu items."
  ' The font object will be destroyed if no handles left (OwnsHandle = True).
  ' A new font object will be created in the [Get] Font Property.
  Set CurFont = Nothing
End Sub

Public Sub RestoreDefaultFont()
Attribute RestoreDefaultFont.VB_Description = "Restores the normal bold font used for menu items."
  ' The font object will be destroyed if no handles left (OwnsHandle = True).
  ' A new font object will be created in the [Get] Font Property.
  Set CurDefaultFont = Nothing
End Sub
