VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Describes an item in a menu."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Member0" ,"MenuItemOwnerDrawing"
Option Explicit

'==================================================================
'
' Menu Item Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the DLL
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the DLL.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' Declarations

Private CurhMenu As OLE_HANDLE
Private CurID As Long ' Actually UINT
Private CurShortCutModifier As ShiftConstants
Private CurShortCutKey As KeyCodeConstants
Private CurBmp As IPicture
Private CurChkBmp As IPicture
Private CurSubMenu As MenuContainer
Private CurOwnDraw As MenuItemOwnerDrawing

'------------------------------------------------------------------------
' Class interface: attaching menu to object

Friend Sub Class_InitProps(ByVal hMenu As OLE_HANDLE, ByVal ID As Long, ByVal ShortCutMod As ShiftConstants, ByVal ShortCutKey As KeyCodeConstants, ByVal CustBmp As IPicture, ByVal CustChkBmp As IPicture, ByVal SubMenu As MenuContainer)
  CurhMenu = hMenu
  CurID = ID
  CurShortCutModifier = ShortCutMod
  CurShortCutKey = ShortCutKey
  Set CurBmp = CustBmp
  Set CurChkBmp = CustChkBmp
  Set CurSubMenu = SubMenu
  Set CurOwnDraw = New MenuItemOwnerDrawing
  Call CurOwnDraw.Class_Attach(CurhMenu, CurID)
End Sub

'------------------------------------------------------------------------
' Class interface: Menu info

Public Property Get ID() As Integer
Attribute ID.VB_Description = "Returns the internal ID used for the menu item."
  ID = CToUINT(CurID)
End Property

Public Property Get ParentMenu() As MenuContainer
  Set ParentMenu = MenuGlobal.MenuAttach(CurhMenu, False)
End Property


'------------------------------------------------------------------------
' Menu Caption property.

' Problem with captions:
' There is a big difference between W98/W2k and older systems
' dwTypeData can contain a bitmap handle or a string pointer!?
' Not on every system we can use MIIM_FTYPE!
' - See MENUITEMINFO topic in MSDN libary

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/Sets the menu item's caption."
  Dim Buffer As String
  Dim Length As Long
  Length = GetMenuString(CurhMenu, CurID, vbNullString, 0, MF_BYCOMMAND)
  Buffer = Space(Length) & vbNullChar
  Length = GetMenuString(CurhMenu, CurID, Buffer, Length + 1, MF_BYCOMMAND)
  Caption = Left(Buffer, Length)
End Property

' Didn't work all the time?!
'Public Property Get Caption() As String
'  Dim Info As MENUITEMINFO
'  Dim Buffer As String
'  Info.cbSize = LenB(Info)
'  Info.fMask = MIIM_TYPE Or MIIM_FTYPE Or MIIM_STRING
'  If GetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Error 5
'  If (Info.fType And mnuFlagSeparator) = mnuFlagSeparator Then Error 5
'  Buffer = Space(Info.cch) & vbNullChar
'  Info.cch = Len(Buffer)
'  Buffer = StrConv(Buffer, vbFromUnicode)
'  Info.dwTypeData = StrPtr(Buffer)
'  If GetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Error 5
'  If Info.dwTypeData <> StrPtr(Buffer) Then Error 5 ' This isn't a string caption
'  Caption = Left(StrConv(Buffer, vbUnicode), Info.cch)
'End Property

Public Property Let Caption(ByVal NewValue As String)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "Caption" & SRC_PROP_GET
  Dim Info As MENUITEMINFO
  Dim OwnerDraw As Boolean ' Ownerdrawn: remove that flag while setting MENUITEMINFO
  
  If NewValue = Me.Caption Then Exit Property ' No refresh, and check for menu type!
  NewValue = StrConv(NewValue, vbFromUnicode)
  
  Info = Menu_GetItemInfo(CurhMenu, CurID, MIIM_TYPE)
  OwnerDraw = (Info.fType And mnuFlagDrawnByOwner) = mnuFlagDrawnByOwner
  Info.fType = Info.fType And Not mnuFlagDrawnByOwner
  Info.cch = Len(NewValue)
  Info.dwTypeData = StrPtr(NewValue)
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
  If OwnerDraw Then Me.MenuType = Info.fType Or mnuFlagDrawnByOwner
End Property

Public Property Get hBmpCaption() As OLE_HANDLE
Attribute hBmpCaption.VB_Description = "Returns the handle to the bitmap used if this menu is a bitmap-style menu."
  Const ERR_SRC = SRC_CLASS_MENUITEM & "hBmpCaption" & SRC_PROP_GET
  Dim Info As MENUITEMINFO
  Info = Menu_GetItemInfo(CurhMenu, CurID, MIIM_TYPE Or MIIM_FTYPE Or MIIM_BITMAP)
  If (Info.fType And mnuFlagBitmap) = mnuFlagBitmap Then hBmpCaption = Info.dwTypeData
End Property

Public Property Let hBmpCaption(ByVal NewValue As OLE_HANDLE)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "hBmpCaption" & SRC_PROP_GET
  Dim Info As MENUITEMINFO
  Info = Menu_GetItemInfo(CurhMenu, CurID, MIIM_TYPE Or MIIM_FTYPE Or MIIM_BITMAP)
  If Info.cch <> 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_NOTBMP)
  If ((Info.fType And mnuFlagBitmap) <> mnuFlagBitmap) Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_NOTBMP)
  Info.dwTypeData = NewValue
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
  If Me.hBmpCaption <> NewValue Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_NOTBMP)
End Property

'------------------------------------------------------------------------
' Get caption-Accelerator/ Shortcut

Public Property Get Accelerator() As String
Attribute Accelerator.VB_Description = "Returns the accelerator key used for this menu item."
  Dim Caption As String
  Dim I As Long
  Caption = Me.Caption
  For I = 1 To Len(Caption)
    If StrComp(Mid(Caption, I, 1), "&") = 0 And StrComp(Mid(Caption, I, 2), "&&") <> 0 Then
      Accelerator = Mid(Caption, I + 1, 1)
      Exit For
    End If
  Next
End Property

Public Property Get ShortCutModifier() As ShiftConstants
Attribute ShortCutModifier.VB_Description = "Returns/Sets the modifier key (Ctrl, Shift, Alt), required to activate the shortcut key code."
  ShortCutModifier = CurShortCutModifier
End Property

Public Property Let ShortCutModifier(ByVal NewValue As ShiftConstants)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "ShortCutModifier" & SRC_PROP_LET
  If (Me.MenuType And mnuFlagSeparator) = mnuFlagSeparator Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SEP)
  If Not Menu_ShortCutValid(NewValue, CurShortCutKey) Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SHORTCUT)
  CurShortCutModifier = NewValue
End Property

Public Property Get ShortCutCode() As KeyCodeConstants
Attribute ShortCutCode.VB_Description = "Returns/Sets the keycode used as shortcut key."
  ShortCutCode = CurShortCutKey
End Property

Public Property Let ShortCutCode(ByVal NewValue As KeyCodeConstants)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "ShortCutCode" & SRC_PROP_LET
  If (Me.MenuType And mnuFlagSeparator) = mnuFlagSeparator Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SEP)
  If Not Menu_ShortCutValid(CurShortCutModifier, NewValue) Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SHORTCUT)
  CurShortCutKey = NewValue
End Property

Public Sub ModifyShortCut(ByVal NewModifier As ShiftConstants, ByVal NewCode As KeyCodeConstants)
Attribute ModifyShortCut.VB_Description = "Allows you to change the shortcut code for the menu item."
  Const ERR_SRC = SRC_CLASS_MENUITEM & "ModifyShortCut" & SRC_SUB
  If (Me.MenuType And mnuFlagSeparator) = mnuFlagSeparator Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SEP)
  If Not Menu_ShortCutValid(NewModifier, NewCode) Then Call RaiseVBDLLError(ERR_SRC, ERR_ITEM_SHORTCUT)
  CurShortCutModifier = NewModifier
  CurShortCutKey = NewCode
End Sub


'------------------------------------------------------------------------
' Menu Standard Bitmaps (like close/open/minimize/maximize)

Public Property Get StandardBitmap() As MenuStandardBitmaps
Attribute StandardBitmap.VB_Description = "Contains the normal monochrome icon bitmap used."
  StandardBitmap = Menu_GetItemInfo(CurhMenu, CurID, MIIM_BITMAP).hBmpItem
End Property

Public Property Let StandardBitmap(ByVal NewValue As MenuStandardBitmaps)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "StandardBitmap" & SRC_PROP_LET
  Dim Info As MENUITEMINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_BITMAP
  Info.hBmpItem = NewValue
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
End Property

'------------------------------------------------------------------------
' Info about the menu style and it's behavour

Public Property Get MenuState() As MenuStateFlags
Attribute MenuState.VB_Description = "Returns/Sets the state flags for the menu item."
  MenuState = Menu_GetItemInfo(CurhMenu, CurID, MIIM_STATE).fState
End Property

Public Property Let MenuState(ByVal NewValue As MenuStateFlags)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "MenuState" & SRC_PROP_LET
  Dim Info As MENUITEMINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_STATE
  Info.fState = NewValue
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
End Property

Public Property Get MenuType() As MenuTypeFlags
Attribute MenuType.VB_Description = "Returns the type of menu."
  MenuType = Menu_GetItemInfo(CurhMenu, CurID, MIIM_FTYPE).fType
End Property

Public Property Let MenuType(ByVal NewValue As MenuTypeFlags)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "MenuType" & SRC_PROP_LET
  Dim Info As MENUITEMINFO
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_FTYPE
  Info.fType = NewValue
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
End Property

'------------------------------------------------------------------------
' Real menu bitmaps
' monochrome bitmaps recommended, because and-bitblt is used
' to make them "transparent". For cool and complex bitmaps,
' the owner drawing flag is required. When that flag is applied,
' the menu item will be drawn by it's owner (or my this DLL)

Public Property Get UnCheckedBitmap() As IPicture
Attribute UnCheckedBitmap.VB_Description = "Contains a monochrome bitmap used as checkicon."
  Dim hBitmap As OLE_HANDLE
  hBitmap = Menu_GetItemInfo(CurhMenu, CurID, MIIM_CHECKMARKS).hbmpUnchecked
  If hBitmap <> CurBmp.Handle Then Set CurBmp = GetPictureObj(hBitmap)
  Set UnCheckedBitmap = CurBmp
End Property

Public Property Set UnCheckedBitmap(ByVal NewValue As IPicture)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "UnCheckedBitmap" & SRC_PROP_SET
  If NewValue Is Nothing Then Err.Raise 380, SRC_CLASS_MENUITEM & "UnCheckedBitmap" & SRC_PROP_SET, ERR_SETIMAGE_NULL
  If Not (TypeOf NewValue Is StdPicture Or TypeOf NewValue Is IPicture Or TypeOf NewValue Is IPictureDisp) Then Err.Raise 380, SRC_CLASS_MENUITEM & "UnCheckedBitmap" & SRC_PROP_SET, ERR_SETIMAGE_TYPE
  Dim Info As MENUITEMINFO
  Info = Menu_GetItemInfo(CurhMenu, CurID, MIIM_CHECKMARKS)
  Info.hbmpUnchecked = NewValue.Handle
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
End Property

Public Property Get CheckedBitmap() As IPicture
Attribute CheckedBitmap.VB_Description = "Returns/Sets a monochrome bitmap used when the menu item is checked."
  Dim hBitmap As OLE_HANDLE
  hBitmap = Menu_GetItemInfo(CurhMenu, CurID, MIIM_CHECKMARKS).hbmpChecked
  If hBitmap <> CurChkBmp.Handle Then Set CurChkBmp = GetPictureObj(hBitmap)
  Set CheckedBitmap = CurChkBmp
End Property

Public Property Set CheckedBitmap(ByVal NewValue As IPicture)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "CheckedBitmap" & SRC_PROP_SET
  If NewValue Is Nothing Then Err.Raise 380, SRC_CLASS_MENUITEM & "CheckedBitmap" & SRC_PROP_SET, ERR_SETIMAGE_NULL
  If Not (TypeOf NewValue Is StdPicture Or TypeOf NewValue Is IPicture Or TypeOf NewValue Is IPictureDisp) Then Err.Raise 380, SRC_CLASS_MENUITEM & "CheckedBitmap" & SRC_PROP_SET, ERR_SETIMAGE_TYPE
  Dim Info As MENUITEMINFO
  Info = Menu_GetItemInfo(CurhMenu, CurID, MIIM_CHECKMARKS)
  Info.hbmpChecked = NewValue.Handle
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
End Property

'------------------------------------------------------------------------
' Reference to object containing more information, which is used when
' this DLL takes over all the painting of the menu item.

Public Property Get DrawExtras() As MenuItemOwnerDrawing
Attribute DrawExtras.VB_Description = "Contains extra drawing parameters, used when owner-drawing is enabled!"
  Set DrawExtras = CurOwnDraw
End Property

'------------------------------------------------------------------------
' Submenu reference.
' Note: When submenu HMENU references (not object references) are
' all destroyed, the popupmenu will be destroyed too!

Public Property Get SubMenu() As MenuContainer
Attribute SubMenu.VB_Description = "Contains the submenu, is assiociated."
  Dim hSubMenu As OLE_HANDLE
  hSubMenu = Menu_GetItemInfo(CurhMenu, CurID, MIIM_SUBMENU).hSubMenu
  If CurSubMenu Is Nothing Then
    If hSubMenu <> 0 Then Set CurSubMenu = MenuGlobal.MenuAttach(hSubMenu, False)
  Else
    If CurSubMenu.hMenu <> hSubMenu Then
      If hSubMenu = 0 Then
        Set CurSubMenu = Nothing
      Else
        Set CurSubMenu = MenuGlobal.MenuAttach(hSubMenu, False)
      End If
    End If
  End If
  Set SubMenu = CurSubMenu
End Property

Public Property Set SubMenu(ByVal NewValue As MenuContainer)
  Const ERR_SRC = SRC_CLASS_MENUITEM & "SubMenu" & SRC_PROP_SET
  Dim Info As MENUITEMINFO
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is MenuContainer Then Call RaiseVBDLLError(ERR_SRC, ERR_TYPE & "MenuContainer!")
    If GetMenuItemCount(NewValue.hMenu) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_SUBMENU_EMPTY)
    Info.hSubMenu = NewValue.hMenu
  Else
    Info.hSubMenu = 0
  End If
  Info.cbSize = LenB(Info)
  Info.fMask = MIIM_SUBMENU
  If SetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_SETITEM)
  If GetMenuItemInfo(CurhMenu, CurID, False, Info) = 0 Then Call RaiseVBDLLError(ERR_SRC, ERR_FAIL_GETITEM)
  If Info.hSubMenu <> NewValue.hMenu Then Err.Raise 51, ERR_SRC, ERR_VALUE & "Submenu doesn't appear to be added to the menu item!"
  Set CurSubMenu = NewValue
End Property

